<!-- HTML header for doxygen 1.8.8-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <!-- For Mobile Devices -->
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
        <meta name="generator" content="Doxygen 1.8.14"/>
        <script type="text/javascript" src="https://code.jquery.com/jquery-2.1.1.min.js"></script>
        <title>libinput: Tablet support</title>
        <!--<link href="tabs.css" rel="stylesheet" type="text/css"/>-->
        <script type="text/javascript" src="dynsections.js"></script>
        <script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" async src="https://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
        <link href="doxygen.css" rel="stylesheet" type="text/css" />
        <link href="bootstrap.css" rel="stylesheet" type="text/css"/>
<link href="customdoxygen.css" rel="stylesheet" type="text/css"/>
<link href="libinputdoxygen.css" rel="stylesheet" type="text/css"/>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.1/js/bootstrap.min.js"></script>
        <script type="text/javascript" src="doxy-boot.js"></script>
    </head>
    <body>
        <nav class="navbar navbar-default" role="navigation">
            <div class="container">
                <div class="navbar-header">
                    <a class="navbar-brand">libinput 1.11.2</a>
                </div>
            </div>
        </nav>
        <div id="top"><!-- do not remove this div, it is closed by doxygen! -->
            <div class="content" id="content">
                <div class="container">
                    <div class="row">
                        <div class="col-sm-12 panel panel-default" style="padding-bottom: 15px;">
                            <div style="margin-bottom: 15px;">
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="tablets.html">Graphics Tablets</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Tablet support </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p><br />
</p>
<p>This page provides details about the graphics tablet support in libinput.</p>
<p>Note that the term "tablet" in libinput refers to graphics tablets only (e.g. Wacom Intuos), not to tablet devices like the Apple iPad.</p>
<div class="image">
<object type="image/svg+xml" data="tablet.svg">tablet.svg</object>
<div class="caption">
Illustration of a graphics tablet</div></div>
 <h1><a class="anchor" id="tablet-tools"></a>
Pad buttons vs. tablet tools</h1>
<p>Most tablets provide two types of devices. The physical tablet often provides a number of buttons and a touch ring or strip. Interaction on the drawing surface of the tablet requires a tool, usually in the shape of a stylus. The libinput interface exposed by devices with the <a class="el" href="group__device.html#gga3110cdddce94a1df0b8a3306909c8f15ad3eafb7274a330c5839f00030850db6d">LIBINPUT_DEVICE_CAP_TABLET_TOOL</a> capability applies only to events generated by tools.</p>
<p>Buttons, rings or strips on the physical tablet hardware (the "pad") are exposed by devices with the <a class="el" href="group__device.html#gga3110cdddce94a1df0b8a3306909c8f15a98ec191d1a685df5cdf87a19b2ee9a9f">LIBINPUT_DEVICE_CAP_TABLET_PAD</a> capability. Pad events do not require a tool to be in proximity. Note that both capabilities may exist on the same device though usually they are split across multiple kernel devices.</p>
<div class="image">
<object type="image/svg+xml" data="tablet-interfaces.svg">tablet-interfaces.svg</object>
<div class="caption">
Difference between Pad and Tool buttons</div></div>
<p> Touch events on the tablet integrated into a screen itself are exposed through the <a class="el" href="group__device.html#gga3110cdddce94a1df0b8a3306909c8f15aad61f92a8154c9017d4e621c768712aa">LIBINPUT_DEVICE_CAP_TOUCH</a> capability. Touch events on a standalone tablet are exposed through the <a class="el" href="group__device.html#gga3110cdddce94a1df0b8a3306909c8f15a6e7c3249a8f0503fce7e0a5effc4d73f">LIBINPUT_DEVICE_CAP_POINTER</a> capability. In both cases, the kernel usually provides a separate event node for the touch device, resulting in a separate libinput device. See <a class="el" href="group__device.html#ga0edc58e5a022b48a8d8416f63d2860df" title="Get the device group this device is assigned to. ">libinput_device_get_device_group()</a> for information on how to associate the touch part with other devices exposed by the same physical hardware.</p>
<h1><a class="anchor" id="tablet-tip"></a>
Tool tip events vs. tool button events</h1>
<p>The primary use of a tablet tool is to draw on the surface of the tablet. When the tool tip comes into contact with the surface, libinput sends an event of type <a class="el" href="group__base.html#ggac30276a06e8b1434b959f2c8dde74f7ca97e12980dafac44aa6b4501e1a6c9a7a">LIBINPUT_EVENT_TABLET_TOOL_TIP</a>, and again when the tip ceases contact with the surface.</p>
<p>Tablet tools may send button events; these are exclusively for extra buttons unrelated to the tip. A button event is independent of the tip and can while the tip is down or up.</p>
<p>Some tablet tools' pressure detection is too sensitive, causing phantom touches when the user only slightly brushes the surfaces. For example, some tools are capable of detecting 1 gram of pressure.</p>
<p>libinput uses a device-specific pressure threshold to determine when the tip is considered logically down. As a result, libinput may send a nonzero pressure value while the tip is logically up. Most application can and should ignore pressure information until they receive the event of type <a class="el" href="group__base.html#ggac30276a06e8b1434b959f2c8dde74f7ca97e12980dafac44aa6b4501e1a6c9a7a">LIBINPUT_EVENT_TABLET_TOOL_TIP</a>. Applications that require extremely fine-grained pressure sensitivity should use the pressure data instead of the tip events to determine a logical tip down state and treat the tip events like axis events otherwise.</p>
<p>Note that the pressure threshold to trigger a logical tip event may be zero on some devices. On tools without pressure sensitivity, determining when a tip is down is device-specific.</p>
<h1><a class="anchor" id="tablet-relative-motion"></a>
Relative motion for tablet tools</h1>
<p>libinput calculates the relative motion vector for each event and converts it to the same coordinate space that a normal mouse device would use. For the caller, this means that the delta coordinates returned by <a class="el" href="group__event__tablet.html#ga868763e264a48cb8df72f5b4724a3c4e" title="Return the delta between the last event and the current event. ">libinput_event_tablet_tool_get_dx()</a> and <a class="el" href="group__event__tablet.html#ga72feb15de8ee3c34a3fa23a78a5c1f3e" title="Return the delta between the last event and the current event. ">libinput_event_tablet_tool_get_dy()</a> can be used identical to the delta coordinates from any other pointer event. Any resolution differences between the x and y axes are accommodated for, a delta of N/N represents a 45 degree diagonal move on the tablet.</p>
<p>The delta coordinates are available for all tablet events, it is up to the caller to decide when a tool should be used in relative mode. It is recommended that mouse and lens cursor tool default to relative mode and all pen-like tools to absolute mode.</p>
<p>If a tool in relative mode must not use pointer acceleration, callers should use the absolute coordinates returned by <a class="el" href="group__event__tablet.html#gab392d487dd9758677066ef8156e7d18c" title="Returns the X coordinate of the tablet tool, in mm from the top left corner of the tablet in its curr...">libinput_event_tablet_tool_get_x()</a> and <a class="el" href="group__event__tablet.html#gab306166e50d78ece22a1241ba59dfdbc" title="Returns the Y coordinate of the tablet tool, in mm from the top left corner of the tablet in its curr...">libinput_event_tablet_tool_get_y()</a> and calculate the delta themselves. Callers that require exact physical distance should also use these functions to calculate delta movements.</p>
<h1><a class="anchor" id="tablet-axes"></a>
Special axes on tablet tools</h1>
<p>A tablet tool usually provides additional information beyond x/y positional information and the tip state. A tool may provide the distance to the tablet surface and the pressure exerted on the tip when in contact. Some tablets additionally provide tilt information along the x and y axis.</p>
<div class="image">
<object type="image/svg+xml" data="tablet-axes.svg">tablet-axes.svg</object>
<div class="caption">
Illustration of the distance, pressure and tilt axes</div></div>
<p> The granularity and precision of the distance and pressure axes varies between tablet devices and cannot usually be mapped into a physical unit. libinput normalizes distance and pressure into the [0, 1] range.</p>
<p>While the normalization range is identical for these axes, a caller should not interpret identical values as identical across axes, i.e. a value v1 on the distance axis has no relation to the same value v1 on the pressure axis.</p>
<p>The tilt axes provide the angle in degrees between a vertical line out of the tablet and the top of the stylus. The angle is measured along the x and y axis, respectively, a positive tilt angle thus means that the stylus' top is tilted towards the logical right and/or bottom of the tablet.</p>
<h1><a class="anchor" id="tablet-fake-proximity"></a>
Handling of proximity events</h1>
<p>libinput's <a class="el" href="group__base.html#ggac30276a06e8b1434b959f2c8dde74f7ca4f726f7db59c83dd948a5ea1d59f57b8">LIBINPUT_EVENT_TABLET_TOOL_PROXIMITY</a> events notify a caller when a tool comes into sensor range or leaves the sensor range. On some tools this range does not represent the physical range but a reduced tool-specific logical range. If the range is reduced, this is done transparent to the caller.</p>
<p>For example, the Wacom mouse and lens cursor tools are usually used in relative mode, lying flat on the tablet. Movement typically follows the interaction normal mouse movements have, i.e. slightly lift the tool and place it in a separate location. The proximity detection on Wacom tablets however extends further than the user may lift the mouse, i.e. the tool may not be lifted out of physical proximity. For such tools, libinput provides software-emulated proximity.</p>
<p>Events from the pad do not require proximity, they may be sent any time.</p>
<h1><a class="anchor" id="tablet-pressure-offset"></a>
Pressure offset on worn-out tools</h1>
<p>When a tool is used for an extended period it can wear down physically. A worn-down tool may never return a zero pressure value. Even when hovering above the surface, the pressure value returned by the tool is nonzero, creating a fake surface touch and making interaction with the tablet less predictable.</p>
<p>libinput automatically detects pressure offsets and rescales the remaining pressure range into the available range, making pressure-offsets transparent to the caller. A tool with a pressure offset will thus send a 0 pressure value for the detected offset and nonzero pressure values for values higher than that offset.</p>
<p>Some limitations apply to avoid misdetection of pressure offsets, specifically:</p><ul>
<li>pressure offset is only detected on proximity in, and if a device is capable of detection distances,</li>
<li>pressure offset is only detected if the distance between the tool and the tablet is high enough,</li>
<li>pressure offset is only used if it is 20% or less of the pressure range available to the tool. A pressure offset higher than 20% indicates either a misdetection or a tool that should be replaced, and</li>
<li>if a pressure value less than the current pressure offset is seen, the offset resets to that value.</li>
</ul>
<p>Pressure offsets are not detected on <a class="el" href="group__device.html#gga8348e628baa2646d31abf0fe7245924fa2544090800eca843af88bb2cf383e92e">LIBINPUT_TABLET_TOOL_TYPE_MOUSE</a> and <a class="el" href="group__device.html#gga8348e628baa2646d31abf0fe7245924fa56a0427909230244aeedad4e48b0384c">LIBINPUT_TABLET_TOOL_TYPE_LENS</a> tools.</p>
<h1><a class="anchor" id="tablet-serial-numbers"></a>
Tracking unique tools</h1>
<p>Some tools provide hardware information that enables libinput to uniquely identify the physical device. For example, tools compatible with the Wacom Intuos 4, Intuos 5, Intuos Pro and Cintiq series are uniquely identifiable through a serial number. libinput does not specify how a tool can be identified uniquely, a caller should use <a class="el" href="group__event__tablet.html#ga22aff11d12f9f4541cc2a8152da62207" title="Return nonzero if the physical tool can be uniquely identified by libinput, or nonzero otherwise...">libinput_tablet_tool_is_unique()</a> to check if the tool is unique.</p>
<p>libinput creates a struct <a class="el" href="structlibinput__tablet__tool.html" title="An object representing a tool being used by a device with the LIBINPUT_DEVICE_CAP_TABLET_TOOL capabil...">libinput_tablet_tool</a> on the first proximity in of this tool. By default, this struct is destroyed on proximity out and re-initialized on the next proximity in. If a caller keeps a reference to the tool by using <a class="el" href="group__event__tablet.html#ga3590fb3c4c03fcfbd2171e6f012a755d" title="Increment the reference count of the tool by one. ">libinput_tablet_tool_ref()</a> libinput re-uses this struct whenever that same physical tool comes into proximity on any tablet recognized by libinput. It is possible to attach tool-specific virtual state to the tool. For example, a graphics program such as the GIMP may assign a specific color to each tool, allowing the artist to use the tools like physical pens of different color. In multi-tablet setups it is also possible to track the tool across devices.</p>
<p>If the tool does not have a unique identifier, libinput creates a single struct <a class="el" href="structlibinput__tablet__tool.html" title="An object representing a tool being used by a device with the LIBINPUT_DEVICE_CAP_TABLET_TOOL capabil...">libinput_tablet_tool</a> per tool type on each tablet the tool is used on.</p>
<h1><a class="anchor" id="tablet-tool-types"></a>
Vendor-specific tablet tool types</h1>
<p>libinput supports a number of high-level tool types that describe the general interaction expected with the tool. For example, a user would expect a tool of type <a class="el" href="group__device.html#gga8348e628baa2646d31abf0fe7245924fa9a76daea205049e4b71b0c30bb203436">LIBINPUT_TABLET_TOOL_TYPE_PEN</a> to interact with a graphics application taking pressure and tilt into account. The default virtual tool assigned should be a drawing tool, e.g. a virtual pen or brush. A tool of type <a class="el" href="group__device.html#gga8348e628baa2646d31abf0fe7245924fa69812dd85e9d5b6775ecaf52ece3c19f">LIBINPUT_TABLET_TOOL_TYPE_ERASER</a> would normally be mapped to an eraser-like virtual tool. See <a class="el" href="group__device.html#ga8348e628baa2646d31abf0fe7245924f">libinput_tablet_tool_type</a> for the list of all available tools.</p>
<p>Vendors may provide more fine-grained information about the tool in use by adding a hardware-specific tool ID. libinput provides this ID to the caller with <a class="el" href="group__event__tablet.html#ga5ba26a193ce809fab9234b2253bcfff8" title="Return the tool ID for a tool object. ">libinput_tablet_tool_get_tool_id()</a> but makes no promises about the content or format of the ID.</p>
<p>libinput currently supports Wacom-style tool IDs as provided on the Wacom Intuos 3, 4, 5, Wacon Cintiq and Wacom Intuos Pro series. The tool ID can be used to distinguish between e.g. a Wacom Classic Pen or a Wacom Pro Pen. It is the caller's responsibility to interpret the tool ID.</p>
<h1><a class="anchor" id="tablet-bounds"></a>
Out-of-bounds motion events</h1>
<p>Some tablets integrated into a screen (e.g. Wacom Cintiq 24HD, 27QHD and 13HD series, etc.) have a sensor larger than the display area. libinput uses the range advertised by the kernel as the valid range unless device-specific quirks are present. Events outside this range will produce coordinates that may be negative or larger than the tablet's width and/or height. It is up to the caller to ignore these events.</p>
<div class="image">
<object type="image/svg+xml" data="tablet-out-of-bounds.svg">tablet-out-of-bounds.svg</object>
<div class="caption">
Illustration of the out-of-bounds area on a tablet</div></div>
<p> In the image above, the display area is shown in black. The red area around the display illustrates the sensor area that generates input events. Events within this area will have negative coordinate or coordinates larger than the width/height of the tablet.</p>
<p>If events outside the logical bounds of the input area are scaled into a custom range with <a class="el" href="group__event__tablet.html#ga3b128b24b9fe19a98cb0aaf3624c5ab7" title="Return the current absolute x coordinate of the tablet tool event, transformed to screen coordinates...">libinput_event_tablet_tool_get_x_transformed()</a> and <a class="el" href="group__event__tablet.html#ga6c19f3b3679c24f26a46192066f64805" title="Return the current absolute y coordinate of the tablet tool event, transformed to screen coordinates...">libinput_event_tablet_tool_get_y_transformed()</a> the resulting value may be less than 0 or larger than the upper range provided. It is up to the caller to test for this and handle or ignore these events accordingly.</p>
<h1><a class="anchor" id="tablet-pad-buttons"></a>
Tablet pad button numbers</h1>
<p>Tablet Pad buttons are numbered sequentially, starting with button 0. Thus button numbers returned by <a class="el" href="group__event__tablet__pad.html#ga4339cf54b0a511599595e8483eea360d" title="Return the button number that triggered this event, starting at 0. ">libinput_event_tablet_pad_get_button_number()</a> have no semantic meaning, a notable difference to the button codes returned by other libinput interfaces (e.g. <a class="el" href="group__event__tablet.html#gae36ab2ab73d8b7f00da4cc33f22699ef" title="Return the button that triggered this event. ">libinput_event_tablet_tool_get_button()</a>).</p>
<p>The Linux kernel requires all input events to have semantic event codes, but generic buttons like those on a pad cannot easily be assigned semantic codes. The kernel supports generic codes in the form of BTN_0 through to BTN_9 and additional unnamed space up until code 0x10f. Additional generic buttons are available as BTN_A in the range dedicated for gamepads and joysticks. Thus, tablet with a large number of buttons have to map across two semantic ranges, have to use unnamed kernel button codes or risk leaking into an unrelated range. libinput transparently maps the kernel event codes into a sequential button range on the pad. Callers should use external sources like libwacom to associate button numbers to their position on the tablet.</p>
<p>Some buttons may have expected default behaviors. For example, on Wacom Intuos Pro series tablets, the button inside the touch ring is expected to switch between modes, see <a class="el" href="tablet-support.html#tablet-pad-modes">Tablet pad modes</a>. Callers should use external sources like libwacom to identify which buttons have semantic behaviors.</p>
<h1><a class="anchor" id="tablet-left-handed"></a>
Tablets in left-handed mode</h1>
<p>Left-handed mode on tablet devices usually means rotating the physical tablet by 180 degrees to move the tablet pad button area to right side of the tablet. When left-handed mode is enabled on a tablet device (see <a class="el" href="group__config.html#ga9bbdef04c07804ce7c121133c04d4edf" title="Set the left-handed configuration of the device. ">libinput_device_config_left_handed_set()</a>) the tablet tool and tablet pad behavior changes. In left-handed mode, the tools' axes are adjusted so that the origin of each axis remains the logical north-east of the physical tablet. For example, the x and y axes are inverted and the positive x/y coordinates are down/right of the top-left corner of the tablet in its current orientation. On a tablet pad, the ring and strip are similarly adjusted. The origin of the ring and strips remain the top-most point.</p>
<div class="image">
<object type="image/svg+xml" data="tablet-left-handed.svg">tablet-left-handed.svg</object>
<div class="caption">
Tablet axes in right- and left-handed mode</div></div>
<p> Pad buttons are not affected by left-handed mode; the number of each button remains the same even when the perceived physical location of the button changes. This is a conscious design decision:</p><ul>
<li>Tablet pad buttons do not have intrinsic semantic meanings. Re-ordering the button numbers would not change any functionality.</li>
<li>Button numbers should not be exposed directly to the user but handled in the intermediate layers. Re-ordering button numbers thus has no user-visible effect.</li>
<li>Re-ordering button numbers may complicate the intermediate layers.</li>
</ul>
<p>Left-handed mode is only available on some tablets, some tablets are symmetric and thus do not support left-handed mode. libinput requires libwacom to determine if a tablet is capable of being switched to left-handed mode.</p>
<h1><a class="anchor" id="tablet-pad-modes"></a>
Tablet pad modes</h1>
<p>Tablet pad modes are virtual groupings of button, ring and strip functionality. A caller may assign different functionalities depending on the mode the tablet is in. For example, in mode 0 the touch ring may emulate scrolling, in mode 1 the touch ring may emulate zooming, etc. libinput handles the modes and mode switching but does not assign specific functionality to buttons, rings or strips based on the mode. It is up to the caller to decide whether the mode only applies to buttons, rings and strips or only to rings and strips (this is the case with the Wacom OS X and Windows driver).</p>
<p>The availability of modes on a touchpad usually depends on visual feedback such as LEDs around the touch ring. If no visual feedback is available, only one mode may be available.</p>
<p>Mode switching is controlled by libinput and usually toggled by one or more buttons on the device. For example, on the Wacom Intuos 4, 5, and Pro series tablets the mode button is the button centered in the touch ring and toggles the modes sequentially. On the Wacom Cintiq 24HD the three buttons next to each touch ring allow for directly changing the mode to the desired setting.</p>
<p>Multiple modes may exist on the tablet, libinput uses the term "mode group" for such groupings of buttons that share a mode and mode toggle. For example, the Wacom Cintiq 24HD has two separate mode groups, one for the left set of buttons, strips, and touch rings and one for the right set. libinput handles the mode groups independently and returns the mode for each button as appropriate. The mode group is static for the lifetime of the device.</p>
<div class="image">
<object type="image/svg+xml" data="tablet-intuos-modes.svg">tablet-intuos-modes.svg</object>
<div class="caption">
Modes on an Intuos Pro-like tablet</div></div>
<p> In the image above, the Intuos Pro-like tablet provides 4 LEDs to indicate the currently active modes. The button inside the touch ring cycles through the modes in a clockwise fashion. The upper-right LED indicates that the currently active mode is 1, based on 0-indexed mode numbering. <a class="el" href="group__event__tablet__pad.html#ga7ba64faefd071d101d21fd347720ea21" title="Returns the mode the button, ring, or strip that triggered this event is in, at the time of the event...">libinput_event_tablet_pad_get_mode()</a> would thus return 1 for all button and ring events on this tablet. When the center button is pressed, the mode switches to mode 2, the LED changes to the bottom-right and <a class="el" href="group__event__tablet__pad.html#ga7ba64faefd071d101d21fd347720ea21" title="Returns the mode the button, ring, or strip that triggered this event is in, at the time of the event...">libinput_event_tablet_pad_get_mode()</a> returns 2 for the center button event and all subsequent events.</p>
<div class="image">
<object type="image/svg+xml" data="tablet-cintiq24hd-modes.svg">tablet-cintiq24hd-modes.svg</object>
<div class="caption">
Modes on an Cintiq 24HD-like tablet</div></div>
<p> In the image above, the Cintiq 24HD-like tablet provides 3 LEDs on each side of the tablet to indicate the currently active mode for that group of buttons and the respective ring. The buttons next to the touch ring select the mode directly. The two LEDs indicate that the mode for the left set of buttons is currently 0, the mode for the right set of buttons is currently 1, based on 0-indexed mode numbering. <a class="el" href="group__event__tablet__pad.html#ga7ba64faefd071d101d21fd347720ea21" title="Returns the mode the button, ring, or strip that triggered this event is in, at the time of the event...">libinput_event_tablet_pad_get_mode()</a> would thus return 0 for all button and ring events on the left and 1 for all button and ring events on the right. When one of the three mode toggle buttons on the right is pressed, the right mode switches to that button's mode but the left mode remains unchanged.</p>
<h1><a class="anchor" id="tablet-touch-arbitration"></a>
Tablet touch arbitration</h1>
<p>"Touch arbitration" is the terminology used when touch events are suppressed while the pen is in proximity. Since it is almost impossible to use a stylus or other tool without triggering touches with the hand holding the tool, touch arbitration serves to reduce the number of accidental inputs. The wacom kernel driver currently provides touch arbitration but for other devices arbitration has to be done in userspace.</p>
<p>libinput uses the <a class="el" href="structlibinput__device__group.html">libinput_device_group</a> to decide on touch arbitration and automatically discards touch events whenever a tool is in proximity. The exact behavior is device-dependent.</p>
<h1><a class="anchor" id="tablet-capabilities"></a>
Required tablet capabilities</h1>
<p>To handle a tablet correctly, libinput requires a set of capabilities on the device. When these capabilities are missing, libinput ignores the device and prints an error to the log. This error messages reads </p><pre>
missing tablet capabilities: xy pen btn-stylus resolution. Ignoring this device.
</pre><p> or in older versions of libinput simply: </p><pre>
libinput bug: device does not meet tablet criteria. Ignoring this device.
</pre><p>When a tablet is rejected, it is usually possible to check the issue with the <code>evemu-descibe</code> tool.</p>
<ul>
<li><b>xy</b> indicates that the tablet is missing the <code>ABS_X</code> and/or <code>ABS_Y</code> axis. This indicates that the device is mislabelled and the udev tag <code>ID_INPUT_TABLET</code> is applied to a device that is not a tablet.</li>
<li><b>pen</b> or <b>btn-stylus</b> indicates that the tablet does not have the <code>BTN_TOOL_PEN</code> or <code>BTN_STYLUS</code> bit set. libinput requires either or both of them to be present. This usually indicates a bug in the kernel driver or the HID descriptors of the device.</li>
<li><b>resolution</b> indicates that the device does not have a resolution set for the x and y axes. This can be fixed with a hwdb entry, locate and read the 60-evdev.hwdb file on your machine to address this. </li>
</ul>
</div></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.8-->
<!-- start footer part -->
</div>
</div>
</div>
</div>
</div>
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.14
</small></address>
</body>
</html>
